unit UnidadConfiguracionServidorIPs;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, inifiles, ScktComp, ComCtrls;

type
  TformConfiguracionServidorIPs = class(TForm)
    GroupBox1: TGroupBox;
    txtIPServidor: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    txtPuerto: TEdit;
    bCancelar: TButton;
    bAceptar: TButton;
    txtUsuario: TEdit;
    Label1: TLabel;
    bComprobarUsuario: TButton;
    txtContrasena: TEdit;
    Label2: TLabel;
    Shape1: TShape;
    socEnvio: TClientSocket;
    be: TStatusBar;
    bDesconectar: TButton;
    gIP: TGroupBox;
    txtIPObtenida: TEdit;
    lIPObtenida: TLabel;
    lDia: TLabel;
    txtDia: TEdit;
    lHora: TLabel;
    txtHora: TEdit;
    StaticText2: TStaticText;
    procedure bCancelarClick(Sender: TObject);
    procedure bAceptarClick(Sender: TObject);
    procedure bComprobarUsuarioClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure socEnvioRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure socEnvioConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure socEnvioConnecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure socEnvioError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure socEnvioWrite(Sender: TObject; Socket: TCustomWinSocket);
    procedure socEnvioDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure bDesconectarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formConfiguracionServidorIPs: TformConfiguracionServidorIPs;

implementation

uses UnidadMenuPrincipal, UnidadProcedimientos;

{$R *.dfm}

procedure TformConfiguracionServidorIPs.bCancelarClick(Sender: TObject);
begin
  Close;
end;

procedure TformConfiguracionServidorIPs.bAceptarClick(Sender: TObject);
begin
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    if tag = 30 then  //Obtener IP PC Remoto
    begin
      WriteString ('Servidor de IPs', 'Obtener IP - IP', txtIPServidor.Text);
      if txtPuerto.Text <> '' then
        WriteInteger ('Servidor de IPs', 'Obtener IP - Puerto', StrToInt(txtPuerto.Text));
      WriteString ('Servidor de IPs', 'Obtener IP - Usuario', txtUsuario.Text);
      WriteString ('Servidor de IPs', 'Obtener IP - Contrasea', txtContrasena.Text);
      vtUsuarioObtenerIP := txtUsuario.Text;
      vtUsuarioObtenerIPContrasena := txtContrasena.Text;
      vtServidorObtenerIPPuerto := txtPuerto.text;
    end
    else
    begin  //Guardar IP PC Remoto
      WriteString ('Servidor de IPs', 'IP', txtIPServidor.Text);
      if txtPuerto.Text <> '' then
        WriteInteger ('Servidor de IPs', 'Puerto', StrToInt(txtPuerto.Text));
      WriteString ('Servidor de IPs', 'Usuario', txtUsuario.Text);
      WriteString ('Servidor de IPs', 'Contrasea',
          encriptar (txtContrasena.Text, claveEncriptacion));
    end;
  finally
    free;
  end;
  close;
end;

procedure TformConfiguracionServidorIPs.bComprobarUsuarioClick(
  Sender: TObject);
begin
  if (txtUsuario.Text = '') or (txtIPServidor.Text = '') or
      (txtPuerto.Text = '') or (txtContrasena.Text = '') then
    MessageDlg('Faltan datos por introducir.', mtError, [mbok], 0)
  else
  begin
    gIP.Visible := false;
    socEnvio.Close;
    socEnvio.Port := strtoint(txtPuerto.Text);
    socEnvio.Host := txtIPServidor.Text;
    socEnvio.Open;
  end;
end;

procedure TformConfiguracionServidorIPs.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  socEnvio.Active := false;
end;

procedure TformConfiguracionServidorIPs.socEnvioRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  datosRecibidos, dia, hora : String;
begin
  datosRecibidos := Socket.ReceiveText;
  If datosRecibidos = 'PASOFINALSERVIDOR' then
  begin
    socEnvio.Active := false;
    be.Panels[0].Text := 'Datos enviados correctamente.';
    be.Refresh;
  end;
  If datosRecibidos = 'PASOCONTRASEANOVALIDA' then
  begin
    socEnvio.Active := false;
    be.Panels[0].Text := 'Error en la contrasea.';
    be.Refresh;
    MessageDlg('La contrasea introducida no coincide con la del usuario: '+
        txtUsuario.Text + '. Recuerde que se tienen en cuenta las maysculas y minsculas.',
        mtError, [mbok], 0);
  end;
  If datosRecibidos = 'PASOUSUARIONOEXISTE' then
  begin
    socEnvio.Active := false;
    be.Panels[0].Text := 'El usuario no existe en el servidor especificado.';
    be.Refresh;
    MessageDlg('El usuario ' + txtUsuario.Text + ' no existe en el servidor especificado.',
        mtError, [mbok], 0);
  end;
  If copy (datosRecibidos, 0, 6) = 'PASOIP' then
  begin
    socEnvio.Active := false;
    txtIPObtenida.Text := copy (datosRecibidos, 7, 21);
    if Length(txtIPObtenida.Text) > 15 then
      txtIPObtenida.Text := trim (copy (txtIPObtenida.Text, 0, 15));
    dia := copy (datosRecibidos, 22, 36);
    if length(dia) > 15 then
      dia := copy (dia, 0, 15);
    dia := trim(dia);
    txtDia.Text := dia;
    hora := copy (datosRecibidos, 37, 51);
    if length(hora) > 15 then
      hora := copy (hora, 0, 15);
    hora := trim(hora);
    txtHora.Text := hora;
    gIP.Visible := true;
    be.Panels[0].Text := 'IP Obtenida ' + txtIPObtenida.Text;
    be.Refresh;
  end;
end;

procedure TformConfiguracionServidorIPs.socEnvioConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  i : integer;
  usuario, ipPublica : string;
begin
  be.Panels[0].Text := 'Conectado a ' + txtIPServidor.Text;
  bComprobarUsuario.Enabled := false;
  bDesconectar.Enabled := true;
  usuario := txtUsuario.Text;
  ipPublica := vtIPPublicaActual;
  //formateamos el texto a enviar con ancho fijo (para enviarlo en una sola vez)
  for i := length(txtUsuario.Text) to 15 do
    usuario := usuario + ' ';
  for i := length(ipPublica) to 15 do
    ipPublica := ipPublica + ' ';
  //Si lo que se pretende es obtener la IP de un usuario
  if Tag = 30 then
  begin
    sleep(2000);
    socEnvio.Socket.SendText('PASOOBTIP' + usuario + txtContrasena.Text);
    socEnvio.Socket.SendText('');
  end
  else
    socEnvio.Socket.SendText('PASODATOS' + usuario + ipPublica + txtContrasena.Text);
  sleep(2000);
  socEnvio.Socket.SendText('PASOFINAL' + usuario);
end;

procedure TformConfiguracionServidorIPs.socEnvioConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  be.Panels[0].Text := 'Intentando conectar a ' + txtIPServidor.Text + ' : '  +
      txtPuerto.Text;
end;

procedure TformConfiguracionServidorIPs.socEnvioError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  errorCode := 0;
  be.Panels[0].Text := 'Error en la conexin a ' + txtIPServidor.Text;
  be.Refresh;
  bComprobarUsuario.Enabled := true;
  bDesconectar.Enabled := false;
end;

procedure TformConfiguracionServidorIPs.socEnvioWrite(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  be.Panels[0].Text := 'Enviando datos a ' + txtIPServidor.Text + ' : ' +
      txtPuerto.Text;
end;

procedure TformConfiguracionServidorIPs.socEnvioDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  be.Panels[0].Text := 'Fin de la conexin';
  be.Refresh;
  bComprobarUsuario.Enabled := true;
  bDesconectar.Enabled := false;  
end;

procedure TformConfiguracionServidorIPs.bDesconectarClick(Sender: TObject);
begin
  socEnvio.Close;
end;

procedure TformConfiguracionServidorIPs.FormShow(Sender: TObject);
begin
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    if Tag = 30 then
    begin
      txtIPServidor.Text := readString ('Servidor de IPs', 'Obtener IP - IP', '');
      txtPuerto.Text := inttostr(ReadInteger ('Servidor de IPs', 'Obtener IP - Puerto', 9989));
      txtUsuario.Text := ReadString ('Servidor de IPs', 'Obtener IP - Usuario', '');
      txtContrasena.Text := ReadString ('Servidor de IPs', 'Obtener IP - Contrasea', '');
    end
    else
    begin
      txtIPServidor.Text := readString ('Servidor de IPs', 'IP', '');
      txtPuerto.Text := inttostr(ReadInteger ('Servidor de IPs', 'Puerto', 9989));
      txtUsuario.Text := ReadString ('Servidor de IPs', 'Usuario', '');
      txtContrasena.Text :=
          desencriptar (ReadString ('Servidor de IPs', 'Contrasea', ''),
          claveEncriptacion);
    end;
  finally
    free;
  end;
  if Tag = 30 then
  begin
    bComprobarUsuario.Caption := '&Obtener IP';
    bComprobarUsuario.Hint := 'Obtiene la IP pblica del Usuario/PC seleccionado, almacenada en el servidor especificado';
    bComprobarUsuario.Default := true;
  end;
end;

end.
