unit UnidadConfigurarServidorBDActual;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, inifiles;

type
  TformConfigurarServidorBDActual = class(TForm)
    tab: TPageControl;
    tabInfo: TTabSheet;
    tabSQL: TTabSheet;
    txtInfo: TMemo;
    Panel1: TPanel;
    bCerrar: TButton;
    Panel2: TPanel;
    opEliminar: TCheckBox;
    bEjecutarSQL: TButton;
    tabDatosConexion: TTabSheet;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    txtIPServidor: TEdit;
    txtPuerto: TEdit;
    txtUsuario: TEdit;
    txtContrasena: TEdit;
    txtBD: TEdit;
    txtTabla: TEdit;
    bProbar: TButton;
    StaticText2: TStaticText;
    Panel3: TPanel;
    txtConsultaSQLEliminacion: TMemo;
    Label1: TLabel;
    Splitter1: TSplitter;
    Panel4: TPanel;
    txtConsultaSQL: TMemo;
    Label8: TLabel;
    bCancelar: TButton;
    TabSheet1: TTabSheet;
    txtFormulario: TMemo;
    Label9: TLabel;
    txtProtocolo: TComboBox;
    Label10: TLabel;
    lInfoProtocolo: TLabel;
    procedure bCerrarClick(Sender: TObject);
    procedure bEjecutarSQLClick(Sender: TObject);
    procedure bProbarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure txtTablaChange(Sender: TObject);
    procedure bCancelarClick(Sender: TObject);
    procedure txtProtocoloChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formConfigurarServidorBDActual: TformConfigurarServidorBDActual;

implementation

uses UnidadModuloDatos, DB, UnidadProcedimientos;

{$R *.dfm}

procedure TformConfigurarServidorBDActual.bCerrarClick(Sender: TObject);
begin
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    WriteString('Servidor BD', 'Servidor', txtIPServidor.Text);
    WriteString('Servidor BD', 'Puerto', txtPuerto.Text);
    WriteString('Servidor BD', 'Usuario conexin', txtUsuario.Text);
    WriteString('Servidor BD', 'Contrasea conexin',
        encriptar (txtContrasena.Text, claveEncriptacion));
    WriteString('Servidor BD', 'BD', txtBD.Text);
    WriteString('Servidor BD', 'Tabla', txtTabla.Text);
    WriteString('Servidor BD', 'Protocolo', txtProtocolo.Text);    
  finally
    Free;
  end;
  close;
end;

procedure TformConfigurarServidorBDActual.bEjecutarSQLClick(
  Sender: TObject);
begin
  try
    md.tcConsultaCreacion.Close;
    md.bd.Connected := false;
    md.bd.LoginPrompt := false;
    md.BD.HostName := txtIPServidor.Text;
    md.BD.Port := strtoint(txtPuerto.Text);
    md.BD.Database := txtBD.Text;
    md.BD.User := txtUsuario.Text;
    md.BD.Password := txtContrasena.Text;
    md.BD.Connected := true;
    if opEliminar.Checked then
    begin
      if MessageDlg('Est seguro que desea eliminar la tabla ' +
          txtTabla.Text + ' y todo su contenido (si existe)?',
          mtConfirmation, [mbyes,mbno], 0) = mryes then
      begin
        md.tcConsultaCreacion.Close;
        md.tcConsultaCreacion.SQL.Clear;
        md.tcConsultaCreacion.SQL.AddStrings(txtConsultaSQLEliminacion.Lines);
        md.tcConsultaCreacion.ExecSQL;
      end;
    end;
    md.tcConsultaCreacion.Close;
    md.tcConsultaCreacion.SQL.Clear;
    md.tcConsultaCreacion.SQL.AddStrings(txtConsultaSQL.Lines);
    md.tcConsultaCreacion.ExecSQL;
    MessageDlg('La consulta de creacin de tabla se ha ejecutado correctamente. ' + chr(13) +
        chr(13) + 'No olvide abrir (mapear/redireccionar) el puerto correspondiente en el router o cortafuegos.',
        mtInformation, [mbok], 0);
  except
    raise;
  end;
end;

procedure TformConfigurarServidorBDActual.bProbarClick(Sender: TObject);
var
  version : string;
begin
  try
    Screen.Cursor := crHourGlass;
    md.tcConsulta.Active := false;
    md.tcConsultaCreacion.Active := false;
    md.BD.Connected := false;
    md.BD.Protocol := txtProtocolo.Text;
    md.BD.LoginPrompt := false;
    md.BD.HostName := txtIPServidor.Text;
    md.BD.Port := strtoint(txtPuerto.Text);
    md.BD.Database := txtBD.Text;
    md.BD.User := txtUsuario.Text;
    md.BD.Password := txtContrasena.Text;
    md.BD.Connected := true;
    //para obtener la versin de MySQL Server
    md.tcConsultaCreacion.SQL.Clear;
    md.tcConsultaCreacion.SQL.Add('SHOW VARIABLES LIKE "version"');
    md.tcConsultaCreacion.Open;
    if md.tcConsultaCreacion.RecordCount > 0 then
      version := md.tcConsultaCreacion.Fields[1].AsString
    else
      version := 'Desconocida';
    Screen.Cursor := crDefault;
    MessageDlg('Conexin realizada correctamente. Se ha encontrado la versin ' +
        version + ' de MySQL Server.' +
        chr(13) + chr(13) +
        'Ahora podr crear la tabla ' +
        ' (en la pestaa "Crear tabla mediante SQL" de esta ventana.',
        mtInformation, [mbok], 0);
    tabSQL.Show;
    md.bd.Disconnect;
  except
    Screen.Cursor := crDefault;  
    raise;
  end;
end;

procedure TformConfigurarServidorBDActual.FormCreate(Sender: TObject);
begin
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    txtIPServidor.Text := readString('Servidor BD', 'Servidor', 'localhost');
    txtPuerto.Text := readString('Servidor BD', 'Puerto', '3306');
    txtUsuario.Text := readString('Servidor BD', 'Usuario conexin', 'root');
    txtContrasena.Text :=
        desencriptar (readString('Servidor BD', 'Contrasea conexin', ''),
        claveEncriptacion);
    txtBD.Text := readString('Servidor BD', 'BD', 'avisoip');
    txtTabla.Text := readString('Servidor BD', 'Tabla', 'ip');
    txtProtocolo.Text := readString('Servidor BD', 'Protocolo', 'mysql-4.1');    
  finally
    Free;
  end;
end;

procedure TformConfigurarServidorBDActual.txtTablaChange(Sender: TObject);
begin
  txtConsultaSQLEliminacion.Lines.Clear;
  txtConsultaSQLEliminacion.Lines.Add ('DROP TABLE IF EXISTS ' + txtTabla.Text);
  txtConsultaSQL.Lines.Clear;
  txtConsultaSQL.Lines.Add ('CREATE TABLE ' + txtTabla.Text + ' (');
  txtConsultaSQL.Lines.Add ('  ID int(10) unsigned NOT NULL auto_increment,');
  txtConsultaSQL.Lines.Add ('  FECHAALTA datetime default NULL,');
  txtConsultaSQL.Lines.Add ('  IPACTUAL varchar(40) default NULL,');
  txtConsultaSQL.Lines.Add ('  USUARIO varchar(20) default NULL,');
  txtConsultaSQL.Lines.Add ('  NOMBRECOMPLETO varchar(100) default NULL,');
  txtConsultaSQL.Lines.Add ('  CONTRASENA varchar(20) default NULL,');
  txtConsultaSQL.Lines.Add ('  FECHACAMBIO datetime default NULL,');
  txtConsultaSQL.Lines.Add ('  PRIMARY KEY  (ID),');
  txtConsultaSQL.Lines.Add ('  UNIQUE KEY id_usuario_ip TYPE HASH (USUARIO)');
  txtConsultaSQL.Lines.Add (') ENGINE=InnoDB DEFAULT CHARSET=latin1;');
end;

procedure TformConfigurarServidorBDActual.bCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TformConfigurarServidorBDActual.txtProtocoloChange(
  Sender: TObject);
begin
  if txtProtocolo.Text = 'mysql-4.1' then
  begin
    lInfoProtocolo.Caption := 'Necesitar la librera: libmysql41.dll';
    txtConsultaSQLEliminacion.Lines.Clear;
    txtConsultaSQLEliminacion.Lines.Add ('DROP TABLE IF EXISTS ' + txtTabla.Text);
    txtConsultaSQL.Lines.Clear;
    txtConsultaSQL.Lines.Add ('CREATE TABLE ' + txtTabla.Text + ' (');
    txtConsultaSQL.Lines.Add ('  ID int(10) unsigned NOT NULL auto_increment,');
    txtConsultaSQL.Lines.Add ('  FECHAALTA datetime default NULL,');
    txtConsultaSQL.Lines.Add ('  IPACTUAL varchar(40) default NULL,');
    txtConsultaSQL.Lines.Add ('  USUARIO varchar(20) default NULL,');
    txtConsultaSQL.Lines.Add ('  NOMBRECOMPLETO varchar(100) default NULL,');
    txtConsultaSQL.Lines.Add ('  CONTRASENA varchar(20) default NULL,');
    txtConsultaSQL.Lines.Add ('  FECHACAMBIO datetime default NULL,');
    txtConsultaSQL.Lines.Add ('  PRIMARY KEY  (ID),');
    txtConsultaSQL.Lines.Add ('  UNIQUE KEY id_usuario_ip TYPE HASH (USUARIO)');
    txtConsultaSQL.Lines.Add (') ENGINE=InnoDB DEFAULT CHARSET=latin1;');
  end;
  if txtProtocolo.Text = 'mysql-4.0' then
  begin
    lInfoProtocolo.Caption := 'Necesitar la librera: libmysql40.dll';
    txtConsultaSQLEliminacion.Lines.Clear;
    txtConsultaSQLEliminacion.Lines.Add ('DROP TABLE IF EXISTS ' + txtTabla.Text);
    txtConsultaSQL.Lines.Clear;
    txtConsultaSQL.Lines.Add ('CREATE TABLE ' + txtTabla.Text + ' (');
    txtConsultaSQL.Lines.Add ('  ID int(10) NOT NULL auto_increment,');
    txtConsultaSQL.Lines.Add ('  FECHAALTA datetime default NULL,');
    txtConsultaSQL.Lines.Add ('  IPACTUAL varchar(40) default NULL,');
    txtConsultaSQL.Lines.Add ('  USUARIO varchar(20) default NULL,');
    txtConsultaSQL.Lines.Add ('  NOMBRECOMPLETO varchar(100) default NULL,');
    txtConsultaSQL.Lines.Add ('  CONTRASENA varchar(20) default NULL,');
    txtConsultaSQL.Lines.Add ('  FECHACAMBIO datetime default NULL,');
    txtConsultaSQL.Lines.Add ('  PRIMARY KEY  (ID)');
    txtConsultaSQL.Lines.Add (');');
  end;
  if txtProtocolo.Text = 'mysql-3.23' then
  begin
    lInfoProtocolo.Caption := 'Necesitar la librera: libmysql323.dll';
    txtConsultaSQLEliminacion.Lines.Clear;
    txtConsultaSQLEliminacion.Lines.Add ('DROP TABLE IF EXISTS ' + txtTabla.Text);
    txtConsultaSQL.Lines.Clear;
    txtConsultaSQL.Lines.Add ('CREATE TABLE ' + txtTabla.Text + ' (');
    txtConsultaSQL.Lines.Add ('  ID int(10) NOT NULL auto_increment,');
    txtConsultaSQL.Lines.Add ('  FECHAALTA datetime default NULL,');
    txtConsultaSQL.Lines.Add ('  IPACTUAL varchar(40) default NULL,');
    txtConsultaSQL.Lines.Add ('  USUARIO varchar(20) default NULL,');
    txtConsultaSQL.Lines.Add ('  NOMBRECOMPLETO varchar(100) default NULL,');
    txtConsultaSQL.Lines.Add ('  CONTRASENA varchar(20) default NULL,');
    txtConsultaSQL.Lines.Add ('  FECHACAMBIO datetime default NULL,');
    txtConsultaSQL.Lines.Add ('  PRIMARY KEY  (ID)');
    txtConsultaSQL.Lines.Add (');');
  end;
  if txtProtocolo.Text = 'mysql-3.20' then
  begin
    lInfoProtocolo.Caption := 'Necesitar la librera: libmysql320.dll';
    txtConsultaSQLEliminacion.Lines.Clear;
    txtConsultaSQLEliminacion.Lines.Add ('DROP TABLE IF EXISTS ' + txtTabla.Text);
    txtConsultaSQL.Lines.Clear;
    txtConsultaSQL.Lines.Add ('CREATE TABLE ' + txtTabla.Text + ' (');
    txtConsultaSQL.Lines.Add ('  ID int(10) NOT NULL auto_increment,');
    txtConsultaSQL.Lines.Add ('  FECHAALTA datetime default NULL,');
    txtConsultaSQL.Lines.Add ('  IPACTUAL varchar(40) default NULL,');
    txtConsultaSQL.Lines.Add ('  USUARIO varchar(20) default NULL,');
    txtConsultaSQL.Lines.Add ('  NOMBRECOMPLETO varchar(100) default NULL,');
    txtConsultaSQL.Lines.Add ('  CONTRASENA varchar(20) default NULL,');
    txtConsultaSQL.Lines.Add ('  FECHACAMBIO datetime default NULL,');
    txtConsultaSQL.Lines.Add ('  PRIMARY KEY  (ID)');
    txtConsultaSQL.Lines.Add (');');
  end;

  if (txtProtocolo.Text <> 'mysql-4.1') and (txtProtocolo.Text <> 'mysql-4.0') and
      (txtProtocolo.Text <> 'mysql-3.23') and (txtProtocolo.Text <> 'mysql-3.20') then
    lInfoProtocolo.Caption := 'Protocolo desconocido';
end;

end.
