unit UnidadEnvioPing;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ScktComp, ComCtrls, inifiles;

type
  TformEnvioPing = class(TForm)
    pEMail: TPanel;
    Label4: TLabel;
    Label6: TLabel;
    txtPuerto: TEdit;
    txtD1: TEdit;
    bCancelar: TButton;
    socEnvioPing: TClientSocket;
    be: TStatusBar;
    mResultado: TMemo;
    Label2: TLabel;
    Panel1: TPanel;
    bEnviar: TButton;
    Label3: TLabel;
    txtD2: TEdit;
    Label5: TLabel;
    txtD3: TEdit;
    Label7: TLabel;
    txtD4: TEdit;
    Label8: TLabel;
    txtH1: TEdit;
    txtH2: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    txtH3: TEdit;
    Label11: TLabel;
    txtH4: TEdit;
    bDetener: TButton;
    procedure bEnviarClick(Sender: TObject);
    procedure socEnvioPingConnecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure socEnvioPingConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure socEnvioPingError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure socEnvioPingRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure socEnvioPingDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bCancelarClick(Sender: TObject);
    procedure txtD1Change(Sender: TObject);
    procedure txtD2Change(Sender: TObject);
    procedure txtD3Change(Sender: TObject);
    procedure txtD4Change(Sender: TObject);
    procedure txtH4Exit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure txtD1KeyPress(Sender: TObject; var Key: Char);
    procedure txtD2KeyPress(Sender: TObject; var Key: Char);
    procedure txtD3KeyPress(Sender: TObject; var Key: Char);
    procedure txtD4KeyPress(Sender: TObject; var Key: Char);
    procedure txtH4KeyPress(Sender: TObject; var Key: Char);
    procedure txtH4Change(Sender: TObject);
    procedure bDetenerClick(Sender: TObject);
  private
    seguir : boolean;
    ipSiguiente : integer;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formEnvioPing: TformEnvioPing;

implementation

{$R *.dfm}

procedure TformEnvioPing.bEnviarClick(Sender: TObject);
begin
  socEnvioPing.Active := false;
  Application.ProcessMessages;
  seguir := true;
  bDetener.Enabled := true;
  bEnviar.Enabled := false;
  mResultado.Clear;
  ipSiguiente := StrToInt(txtD4.Text);
  socEnvioPing.Port := StrToInt(txtPuerto.Text);
  socEnvioPing.Host := txtD1.Text + '.' + txtD2.Text + '.' + txtD3.Text +
      '.' + IntToStr(ipSiguiente);
  socEnvioPing.Active := true;
end;

procedure TformEnvioPing.socEnvioPingConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  be.Panels[0].Text := 'Conectando a ' + txtD1.Text + '.' + txtD2.Text + '.' +
        txtD3.Text + '.' + inttostr(ipSiguiente);
  be.Refresh;
end;

procedure TformEnvioPing.socEnvioPingConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  be.Panels[0].Text := 'Conectado a ' + txtD1.Text + '.' + txtD2.Text + '.' +
        txtD3.Text + '.' + inttostr(ipSiguiente) ;
  be.Refresh;
  mResultado.Lines.Add(txtD1.Text + '.' + txtD2.Text + '.' +
        txtD3.Text + '.' + inttostr(ipSiguiente) + ' -> ' + 'Conexin establecida');
end;

procedure TformEnvioPing.socEnvioPingError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  be.Panels[0].Text := 'Error al conectar a ' +  txtD1.Text + '.' + txtD2.Text + '.' +
        txtD3.Text + '.' + inttostr(ipSiguiente);
  be.Refresh;
  mResultado.Lines.Add(txtD1.Text + '.' + txtD2.Text + '.' +
        txtD3.Text + '.' + inttostr(ipSiguiente) + ' -> ' + 'No disponible');
  ErrorCode := 0;
  if seguir and (ipSiguiente < StrToInt(txtH4.Text)) then
  begin
    ipSiguiente := ipSiguiente + 1;
    socEnvioPing.Active := false;
    socEnvioPing.Host := txtD1.Text + '.' + txtD2.Text + '.' +
        txtD3.Text + '.' + inttostr(ipSiguiente);
    socEnvioPing.Active := true;
  end
  else
  begin
    bEnviar.Enabled := true;
    bDetener.Enabled := false;
    socEnvioPing.Active := false;
    be.Panels[0].Text := 'Ping finalizado';
    be.Refresh;
  end;
end;

procedure TformEnvioPing.socEnvioPingRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  mResultado.Lines.Add(txtD1.Text + '.' + txtD2.Text + '.' +
        txtD3.Text + '.' + inttostr(ipSiguiente) + ' -> ' + Socket.ReceiveText);
  be.Panels[0].Text := 'Leyendo texto desde '  + txtD1.Text + '.' + txtD2.Text + '.' +
        txtD3.Text + '.' + inttostr(ipSiguiente);
  be.Refresh;
  if seguir and (ipSiguiente < StrToInt(txtH4.Text)) then
  begin
    ipSiguiente := ipSiguiente + 1;
    socEnvioPing.Active := false;
    socEnvioPing.Host := txtD1.Text + '.' + txtD2.Text + '.' +
        txtD3.Text + '.' + inttostr(ipSiguiente);
    socEnvioPing.Active := true;
  end
  else
  begin
    bEnviar.Enabled := true;
    bDetener.Enabled := false;
    socEnvioPing.Active := false;
    be.Panels[0].Text := 'Ping finalizado';
    be.Refresh;
  end;
end;

procedure TformEnvioPing.socEnvioPingDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  be.Panels[0].Text := 'Desconectado';
  be.Refresh;
end;

procedure TformEnvioPing.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    if txtPuerto.Text <> '' then
      WriteInteger('Ping', 'Puerto Envo', strtoint(txtPuerto.Text));
    WriteString ('Ping', 'IP Envo 1', txtD1.Text);
    WriteString ('Ping', 'IP Envo 2', txtD2.Text);
    WriteString ('Ping', 'IP Envo 3', txtD3.Text);
    WriteString ('Ping', 'IP Envo 4', txtD4.Text);    
    WriteString ('Ping', 'IP Envo Hasta 1', txtH1.Text);
    WriteString ('Ping', 'IP Envo Hasta 2', txtH2.Text);
    WriteString ('Ping', 'IP Envo Hasta 3', txtH3.Text);
    WriteString ('Ping', 'IP Envo Hasta 4', txtH4.Text);
  finally
    free;
  end;
  Action := caFree;
end;

procedure TformEnvioPing.bCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TformEnvioPing.txtD1Change(Sender: TObject);
begin
  try
    if Length(txtD1.Text) = 3 then
      txtD2.SetFocus;
    txtH1.Text := txtD1.Text;
  except
  end;
end;

procedure TformEnvioPing.txtD2Change(Sender: TObject);
begin
  try
    if Length(txtD2.Text) = 3 then
      txtD3.SetFocus;
    txtH2.Text := txtD2.Text;
  except
  end;
end;

procedure TformEnvioPing.txtD3Change(Sender: TObject);
begin
  try
    if Length(txtD3.Text) = 3 then
      txtD4.SetFocus;
    txtH3.Text := txtD3.Text;
  except
  end;
end;

procedure TformEnvioPing.txtD4Change(Sender: TObject);
begin
  try
    if Length(txtD4.Text) = 3 then
      txtH4.SetFocus;
    txtH4.Text := txtD4.Text;
  except
  end;
end;

procedure TformEnvioPing.txtH4Exit(Sender: TObject);
begin
 if StrToInt(txtH4.Text) < StrToInt(txtD4.Text) then
 begin
   MessageDlg ('La IP desde la que desee hacer ping no puede ser menor ' +
       'que la IP hasta la que desee hacer ping', mtWarning, [mbok], 0);
   txtH4.SetFocus;
 end;
end;

procedure TformEnvioPing.FormShow(Sender: TObject);
begin
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    txtPuerto.Text := inttostr(readinteger ('Ping', 'Puerto Envo', 9988));
    txtD1.Text := readString ('Ping', 'IP Envo 1', '');
    txtD2.Text := readString ('Ping', 'IP Envo 2', '');
    txtD3.Text := readString ('Ping', 'IP Envo 3', '');
    txtD4.Text := readString ('Ping', 'IP Envo 4', '');
    txtH1.Text := readString ('Ping', 'IP Envo Hasta 1', '');
    txtH2.Text := readString ('Ping', 'IP Envo Hasta 2', '');
    txtH3.Text := readString ('Ping', 'IP Envo Hasta 3', '');
    txtH4.Text := readString ('Ping', 'IP Envo Hasta 4', '');
  finally
    free;
  end;
end;

procedure TformEnvioPing.txtD1KeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
  begin
    txtD2.SetFocus;
    Key := chr(0);
  end;
end;

procedure TformEnvioPing.txtD2KeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
  begin
    txtD3.SetFocus;
    Key := chr(0);
  end;
end;

procedure TformEnvioPing.txtD3KeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
  begin
    txtD4.SetFocus;
    Key := chr(0);
  end;
end;

procedure TformEnvioPing.txtD4KeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
  begin
    txtH4.SetFocus;
    Key := chr(0);
  end;
end;

procedure TformEnvioPing.txtH4KeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
  begin
    bEnviar.SetFocus;
    Key := chr(0);
  end;
end;

procedure TformEnvioPing.txtH4Change(Sender: TObject);
begin
  try
    if Length(txtH4.Text) = 3 then
      bEnviar.SetFocus;
  except
  end;
end;

procedure TformEnvioPing.bDetenerClick(Sender: TObject);
begin
  seguir := false;
  bEnviar.Enabled := true;
  bDetener.Enabled := false;
  socEnvioPing.Active := false;
  be.Panels[0].Text := 'Ping cancelado por el usuario';
  be.Refresh;
end;

end.
