unit UnidadObtenerIPBD;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, inifiles, LbCipher, LbClass;

type
  TformObtenerIPBD = class(TForm)
    sb: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    txtIPServidor: TEdit;
    txtPuerto: TEdit;
    txtUsuario: TEdit;
    txtContrasena: TEdit;
    txtBD: TEdit;
    bProbar: TButton;
    txtTabla: TComboBox;
    GroupBox2: TGroupBox;
    txtUsuarioServidorBD: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    txtContrasenaServidorBD: TEdit;
    bGuardar: TButton;
    Panel1: TPanel;
    bCancelar: TButton;
    gIP: TGroupBox;
    lIPObtenida: TLabel;
    lDia: TLabel;
    txtIPObtenida: TEdit;
    txtFecha: TEdit;
    bObtenerIP: TButton;
    Label10: TLabel;
    txtProtocolo: TComboBox;
    lInfoProtocolo: TLabel;
    Label9: TLabel;
    txtOtroDato: TEdit;
    StaticText2: TStaticText;
    bOpciones: TButton;
    procedure bProbarClick(Sender: TObject);
    procedure bObtenerIPClick(Sender: TObject);
    procedure bGuardarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bCancelarClick(Sender: TObject);
    procedure txtProtocoloChange(
  Sender: TObject);
    procedure bOpcionesClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formObtenerIPBD: TformObtenerIPBD;

implementation

uses UnidadModuloDatos, DB, UnidadProcedimientos;

{$R *.dfm}

function obtenerMySQLTablas () : TStringList;
var
  lista : TStringList;
begin
  lista := TStringList.Create;
  md.tcConsultaCreacion.Close;
  md.tcConsultaCreacion.SQL.Clear;
  md.tcConsultaCreacion.SQL.Add('SHOW TABLES');
  try
  md.tcConsultaCreacion.Open;
    while not md.tcConsultaCreacion.Eof do
    begin
      lista.Add (md.tcConsultaCreacion.Fields[0].AsString);
      md.tcConsultaCreacion.Next;
    end;
    Result := lista;
  except
    Result := lista;
  end;
end;


procedure TformObtenerIPBD.bProbarClick(Sender: TObject);
begin
  try
    Screen.Cursor := crHourGlass;
    md.tcConsulta.Active := false;
    md.BD.Connected := false;
    md.BD.LoginPrompt := false;
    md.bd.Protocol := txtProtocolo.Text;
    md.BD.HostName := txtIPServidor.Text;
    md.BD.Port := strtoint(txtPuerto.Text);
    md.BD.Database := txtBD.Text;
    md.BD.User := txtUsuario.Text;
    md.BD.Password := txtContrasena.Text;
    md.BD.Connected := true;
    Screen.Cursor := crDefault;
    MessageDlg('Conexin realizada correctamente.', mtInformation, [mbok], 0);
    txtTabla.Items.Clear;
    txtTabla.Items.AddStrings(obtenerMySQLTablas);
  except
    Screen.Cursor := crDefault;  
    raise;
  end;
end;

procedure TformObtenerIPBD.bObtenerIPClick(Sender: TObject);
begin
  try
    Screen.Cursor := crHourGlass;
    md.tcConsultaCreacion.Active := false;
    md.BD.Connected := false;
    md.BD.LoginPrompt := false;
    md.bd.Protocol := txtProtocolo.Text;
    md.BD.HostName := txtIPServidor.Text;
    md.BD.Port := strtoint(txtPuerto.Text);
    md.BD.Database := txtBD.Text;
    md.BD.User := txtUsuario.Text;
    md.BD.Password := txtContrasena.Text;
    md.BD.Connected := true;
    md.tcConsultaCreacion.SQL.Clear;
    md.tcConsultaCreacion.SQL.Add('SELECT USUARIO, CONTRASENA, IPACTUAL, FECHACAMBIO, NOMBRECOMPLETO FROM ' + txtTabla.Text +
        ' WHERE USUARIO = :pUsuario AND CONTRASENA = :pContrasena');
    md.tcConsultaCreacion.ParamByName('pUsuario').DataType := ftstring;
    md.tcConsultaCreacion.ParamByName('pUsuario').Value :=
        AnsiUpperCase (txtUsuarioServidorBD.Text);
    md.tcConsultaCreacion.ParamByName('pContrasena').DataType := ftstring;
    md.tcConsultaCreacion.ParamByName('pContrasena').Value :=
        encriptar (txtContrasenaServidorBD.Text, claveEncriptacionContraUsuario);
    md.tcConsultaCreacion.Open;
    if md.tcConsultaCreacion.RecordCount > 0 then
    begin
      txtIPObtenida.Text := md.tcConsultaCreacion.fieldbyname('IPACTUAL').AsString;
      txtFecha.Text := md.tcConsultaCreacion.fieldbyname('FECHACAMBIO').AsString;
      txtOtroDato.Text := md.tcConsultaCreacion.fieldbyname('NOMBRECOMPLETO').AsString;
      gIP.Visible := true;
      Screen.Cursor := crDefault;      
    end
    else
    begin
      Screen.Cursor := crDefault;
      MessageDlg('El usuario ' + txtUsuarioServidorBD.Text +
          ' no existe o la contrasea es incorrecta.', mtWarning, [mbok], 0);
      txtUsuarioServidorBD.SetFocus;
    end;
  except
    Screen.Cursor := crDefault;
    raise;
  end;
end;

procedure TformObtenerIPBD.bGuardarClick(Sender: TObject);
begin
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    WriteString('Obtener IP BD', 'Servidor', txtIPServidor.Text);
    WriteString('Obtener IP BD', 'Puerto', txtPuerto.Text);
    WriteString('Obtener IP BD', 'Usuario conexin', txtUsuario.Text);
    WriteString('Obtener IP BD', 'Contrasea conexin',
         encriptar (txtContrasena.Text, claveEncriptacion));
    WriteString('Obtener IP BD', 'BD', txtBD.Text);
    WriteString('Obtener IP BD', 'Tabla', txtTabla.Text);
    WriteString('Obtener IP BD', 'Contrasea',
        encriptar (txtContrasenaServidorBD.Text, claveEncriptacionContraUsuario));
    WriteString('Obtener IP BD', 'Usuario', txtUsuarioServidorBD.Text);
    WriteString('Obtener IP BD', 'Protocolo', txtProtocolo.Text);
  finally
    Free;
  end;
  close;
end;

procedure TformObtenerIPBD.FormCreate(Sender: TObject);
begin
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    txtIPServidor.Text := readString('Obtener IP BD', 'Servidor', 'ajpdsoft.com');
    txtPuerto.Text := readString('Obtener IP BD', 'Puerto', '3306');
    txtUsuario.Text := readString('Obtener IP BD', 'Usuario conexin', 'bdavisoip');
    txtContrasena.Text :=
        desencriptar (readString('Obtener IP BD', 'Contrasea conexin', ''),
        claveEncriptacion);
    txtBD.Text := readString('Obtener IP BD', 'BD', 'bdavisoip');
    txtTabla.Text := readString('Obtener IP BD', 'Tabla', 'ip');
    txtContrasenaServidorBD.Text :=
        desencriptar (readString('Obtener IP BD', 'Contrasea', ''), claveEncriptacionContraUsuario);
    txtUsuarioServidorBD.Text := readString('Obtener IP BD', 'Usuario', '');
    txtProtocolo.Text := ReadString('Obtener IP BD', 'Protocolo', 'mysql-4.1');    
  finally
    Free;
  end;
end;

procedure TformObtenerIPBD.bCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TformObtenerIPBD.txtProtocoloChange(
  Sender: TObject);
begin
  if txtProtocolo.Text = 'mysql-4.1' then
    lInfoProtocolo.Caption := 'Necesitar la librera: libmysql41.dll';
  if txtProtocolo.Text = 'mysql-4.0' then
    lInfoProtocolo.Caption := 'Necesitar la librera: libmysql40.dll';
  if txtProtocolo.Text = 'mysql-3.23' then
    lInfoProtocolo.Caption := 'Necesitar la librera: libmysql323.dll';
  if txtProtocolo.Text = 'mysql-3.20' then
    lInfoProtocolo.Caption := 'Necesitar la librera: libmysql320.dll';
  if (txtProtocolo.Text <> 'mysql-4.1') and (txtProtocolo.Text <> 'mysql-4.0') and
      (txtProtocolo.Text <> 'mysql-3.23') and (txtProtocolo.Text <> 'mysql-3.20') then
    lInfoProtocolo.Caption := 'Protocolo desconocido';
end;

procedure TformObtenerIPBD.bOpcionesClick(Sender: TObject);
begin
  //opciones avanzadas
  if not sb.Visible then
  begin
    sb.Visible := true;
    Height := 390;
  end
  else
  begin //modo normal
    sb.Visible := false;
    Height := 228;
  end;
end;

end.
