unit UnidadProcedimientos;

interface

uses IdHTTP, Classes, SysUtils, IdSMTP, IdMessage, registry, windows;

function ObtenerIPPublicaPCLocal(webIP, textoBuscar : string) : string;
function ConectarServidorEmail (servidor : string; usuario : string; puerto : integer) : boolean;
function enviarEmail (servidor : string; usuario : string; contrasena : string;
    puerto : integer; asunto : string; mensaje : TStringList; conAutenticacion : boolean;
    emisor : string; nombreEmisor : string; destinatario : string; cc : string) : boolean;
procedure ejecutarInicio ();
procedure quitarEjecutarInicio ();
function encriptarFrase (texto : string; ppaso : string) : string;
function desencriptarFrase (texto : string; ppaso : string) : string;
function encriptar(aStr: String; aKey : integer): String;
function desencriptar(aStr: String; aKey : integer): String;

var
  vtServidorEMail : string;
  vtEMailAutenticacion : Boolean;
  vtEMailContrasena : string;
  vteMailDestinatario : string;
  vteMailEmisor : string;
  vtpuerto : integer;
  vtnombreEmisor : string;
  vteMailCC : string;
  vtmensajeTexto : TStringList;
  vtasuntoEMail : string;
  vtUsuarioEMail : string;
  vtpuertoPing : Integer;
  vttextoEnvioPing : string;
  vtpuertoServidorIP : integer;
  vtficheroIPs : string;
  vtIPServidorIP : string;
  vtUsuarioServidorIP : string;
  vtUsuarioObtenerIP : string;
  vtUsuarioObtenerIPContrasena : string;
  vtServidorObtenerIPPuerto : string;
  vtContrasenaServidorIP : string;
  vtwebIPPublica : string;
  vttextoBuscarIPPublica : string;
  vtIPPublicaActual : string;
  vtEjecutarFicheroArchivo : string;
  vtEjecutarFicheroParametro : string;
  vtEjecutarFicheroInicio : boolean;
  vtEjecutarDirecto : boolean;
  vtEjecutarFicheroComprobarIP : boolean;
  vtEjecutarFicheroUsuarioDefecto : boolean;
  vtGuardarLog : boolean;
  vtUsuarioConexionBDServidorBD : string;  //usuario con el que inciaremos sesin en la BD (tiene que existir en la BD)
  vtContrasenaConexionBDServidorBD : string;
  vtIPServidorBD : string;
  vtPuertoServidorBD : Integer;
  vtBDServidorBD : string;
  vtTablaServidorBD : string;
  vtContrasenaServidorBD : string;
  vtUsuarioServidorBD : string;  //usuario que se buscar en la tabla para obtener su IP
  vtServidorBDProtocolo : string;  //versin de la MySQL Server
  vtCerrarAplicacion : Boolean;

const
  claveEncriptacion = 24;
  claveEncriptacionContraUsuario = 19;

implementation

uses UnidadMenuPrincipal;

var
  compEnvioEmail : TIdSMTP;



//encriptar datos
function encriptar(aStr: String; aKey: Integer): String;
begin
   Result:='';
   RandSeed:=aKey;
   for aKey:=1 to Length(aStr) do
       Result:=Result+Chr(Byte(aStr[aKey]) xor random(256));
end;

//desencriptar datos
function desencriptar(aStr: String; aKey: Integer): String;
begin
   Result:='';
   RandSeed:=aKey;
   for aKey:=1 to Length(aStr) do
       Result:=Result+Chr(Byte(aStr[aKey]) xor random(256));
end;


function encriptarFrase (texto : string; ppaso : string) : string;
//var
//  textoEncriptado : string;
begin
{  GenerateLMDKey(Key64, SizeOf(Key64), ppaso);
  EncryptStream (texto, textoEncriptado, Key128, true);}
end;

function desencriptarFrase (texto : string; ppaso : string) : string;
begin
//
end;

procedure quitarEjecutarInicio ();
var
  reg: TRegistry;
begin
  reg := TRegistry.Create;
  reg.RootKey := HKEY_LOCAL_MACHINE;
  reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', false);
  reg.DeleteValue('AjpdSoft Aviso Cambio IP Pblica');
  reg.CloseKey;
  reg.Free;
end;

procedure ejecutarInicio ();
var
  reg : tregistry;
begin
  Reg := TRegistry.Create(KEY_WRITE);
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    if Reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Run', True) then
    begin
      try
        Reg.WriteString('AjpdSoft Aviso Cambio IP Pblica',
            ExtractFilePath(ParamStr(0)) + ExtractFileName(ParamStr(0)));
      except
        Reg.CloseKey;
        raise;
      end;
    end;
    Reg.CloseKey;
  finally
    Reg.Free;
  end;
end;


//Obtener IP pblica pc local
function ObtenerIPPublicaPCLocal(webIP, textoBuscar : string) : string;
var
  obtenerHTTP : TidHTTP;
  web : TStringList;
  i, posCar : integer;
  lineaActual, lineaCor, ip : string;
begin
  web := TStringList.Create;
  obtenerHTTP := TidHTTP.Create(nil);
  try    
    web.Text := obtenerHTTP.Get(webIP);
    obtenerHTTP.Free;
  except
    on E : Exception do
    begin
      if vtGuardarLog then
        formmenuprincipal.mLog.Lines.Add(DateToStr (date) + ' - ' + TimeToStr (time) +
            ' Error al obtener IP de ' + webIP + ': [' + E.ClassName + '] ' +
            e.Message);
      obtenerHTTP.Free;
      obtenerIPPublicaPCLocal := '';
      exit;
    end;
  end;

  for i := 0 to web.Count do
  begin
    lineaActual := web.Strings[i];
    if Pos (textoBuscar, lineaActual) <> 0 then
    begin
      lineaCor := copy (lineaActual, Pos (textoBuscar, lineaActual)
          + length(textoBuscar), length(lineaActual));
      posCar := 1;
      ip := '';
      while (lineaCor[posCar] in ['0'..'9']) or (lineaCor[posCar] = '.') do
      begin
        ip := ip + lineaCor[posCar];
        posCar := posCar + 1;
      end;
      Break;
    end;
  end;
  ObtenerIPPublicaPCLocal := ip;
end;

//Funcin para conectar con el servidor de email
function ConectarServidorEmail (servidor : string; usuario : string; puerto : integer) : boolean;
begin
  compEnvioEmail := TIdSMTP.Create(nil);
  compEnvioEmail.host := servidor;
  compEnvioEmail.userid := usuario;
  compEnvioEmail.Port := puerto;
  try
    compEnvioEmail.connect;
    ConectarServidorEmail := true;
  except
    on E : Exception do
    begin
      if vtGuardarLog then
        formmenuprincipal.mLog.Lines.Add(DateToStr (date) + ' - ' + TimeToStr (time) +
            ' Error en la conexin con ' + servidor + ': [' + E.ClassName + '] ' +
            e.Message);
      compEnvioEmail.Free;
      ConectarServidorEmail := false;
    end;
  end;
end;

//enviar email
function enviarEmail (servidor : string; usuario : string; contrasena : string;
    puerto : integer; asunto : string; mensaje : TStringList; conAutenticacion : boolean;
    emisor : string; nombreEmisor : string; destinatario : string; cc : string) : boolean;
var
  compMensaje : TIdMessage;
  envioCorrecto : boolean;
begin
  if conAutenticacion then
  begin
    compEnvioEmail.AuthenticationType := atLogin;
    compEnvioEmail.UserId := usuario;
    compEnvioEmail.Password := contrasena;
  end
  else
    compEnvioEmail.AuthenticationType := atNone;
  compMensaje := TIdMessage.Create (nil);  
  compMensaje.From.Address := emisor;
  compMensaje.From.Name := nombreEmisor;
  compMensaje.Recipients.Add.Address := destinatario;
  compMensaje.CCList.Add.Address := cc;
  compMensaje.Body.AddStrings (mensaje);
  compMensaje.Subject := asunto;
  compMensaje.ReplyTo.Add.Address := emisor;
  envioCorrecto := true;
  try
    compEnvioEmail.Send(compMensaje);
  except
    on E : Exception do
    begin
      if vtGuardarLog then
        formmenuprincipal.mLog.Lines.Add(DateToStr (date) + ' - ' + TimeToStr (time) +
            ' Error al enviar email a ' + destinatario + ': [' + E.ClassName + '] ' +
            e.Message);
      envioCorrecto := false;
    end;
  end;
  compMensaje.Free;
  enviarEmail := envioCorrecto;
end;

end.
